function editanfis()
// editanfis A GUI for creating ANFIS model interactively
//
//    ANFISLAB: Toolbox de ANFIS (ADAPTATIVE-NETWORK-BASED-FUZZY INFERENCE SYSTEM) para SCILAB
//    Creado Por Andres G. Avendaño Cabezas., Universidad Central de Venezuela (andrewg.avendano@gmail.com),
//    Agosto de 2009, con adaptaciones del codigo ANFIS de dominio publico de Jyh-shing Roger Jang
//    (http://www.cs.nthu.edu.tw/~jang/publication.htm) y FISLAB de G. Ortega.
//    Este programa fue probado en SCILAB version 5.1.1, PC Intel Core(TM) Duo 2,1Ghz, corriendo Linux 2.6.27.7.
//    
//    The program was made to be "atom compatible" by Tan C.L.
//    It also modified to work seamlessly with sciFLT to provide more
//    powerful tools for neuro-fuzzy domain. 
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 2 of the License, or
//    (at your option) any later version.
//    
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//    
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/
//
// Calling Sequence
//     editanfis
//
// Description
//    This GUI let the user to load the data from file or workspace, and train the ANFIS model.
// 
// See also
//    anfis
//    initanfis
//
// Authors
//     Andres G. Avendaño Cabezas, Jyh-shing Roger Jang, Tan C.L. 
//

f=figure('figure_position',[501,19],'figure_size',[692,635],'auto_resize','on','background',[33],'figure_name','Graphic window number %d');
//////////
delmenu(f.figure_id,gettext('File'))
delmenu(f.figure_id,gettext('?'))
delmenu(f.figure_id,gettext('Tools'))
toolbar(f.figure_id,'off')
handles.dummy = 0;
handles.axes1= newaxes();handles.axes1.margins = [ 0 0 0 0];handles.axes1.axes_bounds = [0.04375,0.027619,0.7209375,0.4503968];
handles.frLoadData=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.0321875,0.00738,0.3765625,0.4649206],'Relief','ridge','SliderStep',[0.01,0.1],'String','Load Data','Style','frame','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','frLoadData','Callback','')
handles.frTrain=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.4275,0.007381,0.3615625,0.4649206],'Relief','ridge','SliderStep',[0.01,0.1],'String','Train ANFIS','Style','frame','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','frTrain','Callback','')
handles.frInfo=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.78,0.52,0.2,0.45],'Relief','ridge','SliderStep',[0.01,0.1],'String','Train ANFIS','Style','frame','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','frTrain','Callback','')
handles.rdTraining=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.055,0.3412698,0.1365625,0.047619],'Relief','flat','SliderStep',[0.01,0.1],'String','Training','Style','radiobutton','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','rdTraining','Callback','rdTraining_callback(handles)')
handles.rdTesting=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.06,0.2837302,0.1365625,0.047619],'Relief','flat','SliderStep',[0.01,0.1],'String','Validating','Style','radiobutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','rdTesting','Callback','rdTesting_callback(handles)')
handles.rdFile=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.2234375,0.3512698,0.11875,0.0396825],'Relief','flat','SliderStep',[0.01,0.1],'String','File','Style','radiobutton','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','rdFile','Callback','rdFile_callback(handles)')
handles.rdWorkspace=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.2484375,0.2957143,0.133125,0.0396825],'Relief','flat','SliderStep',[0.01,0.1],'String','Workspace','Style','radiobutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','rdWorkspace','Callback','rdWorkspace_callback(handles)')
handles.pbLoad=uicontrol(f,'unit','normalized','BackgroundColor',[0.6,0.6,0.6],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[18],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.0565625,0.2003968,0.325,0.0596032],'Relief','raised','SliderStep',[0.01,0.1],'String','$Load Data$','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','pbLoad','Callback','pbLoad_callback(handles)')
handles.pbClear=uicontrol(f,'unit','normalized','BackgroundColor',[0.6,0.6,0.6],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[18],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.058125,0.1329365,0.321875,0.0576984],'Relief','raised','SliderStep',[0.01,0.1],'String','$Clear Data$','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','pbClear','Callback','pbClear_callback(handles)')
handles.pbDemo=uicontrol(f,'unit','normalized','BackgroundColor',[0.6,0.6,0.6],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[18],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.108125,0.0429365,0.221875,0.0576984],'Relief','raised','SliderStep',[0.01,0.1],'String','$Demo Data$','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','pbClear','Callback','pbDemo_callback(handles)')



handles.txtType=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.0625,0.4087302,0.128125,0.0357143],'Relief','flat','SliderStep',[0.01,0.1],'String','Data :','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtType','Callback','')
handles.txtFrom=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.2546875,0.4107937,0.0703125,0.0376984],'Relief','flat','SliderStep',[0.01,0.1],'String','From :','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtFrom','Callback','')
handles.popMF=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.6125,0.396087,0.1603125,0.05],'Relief','flat','SliderStep',[0.01,0.1],'String','gbellmf|trimf|trapmf','Style','popupmenu','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','popMF','Callback','popMF_callback(handles)')
handles.popMethod=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.4415847,0.396087,0.16,0.05],'Relief','flat','SliderStep',[0.01,0.1],'String','Hybrid(Offline)|Hybrid(Online)','Style','popupmenu','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','popMethod','Callback','popMethod_callback(handles)')
handles.editNummf=uicontrol(f,'unit','normalized','BackgroundColor',[1,1,1],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.6325,0.3179365,0.115625,0.047619],'Relief','sunken','SliderStep',[0.01,0.1],'String','3','Style','edit','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','editNummf','Callback','editNummf_callback(handles)')
handles.editIter=uicontrol(f,'unit','normalized','BackgroundColor',[1,1,1],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.6325,0.2511376,0.115625,0.047619],'Relief','sunken','SliderStep',[0.01,0.1],'String','10','Style','edit','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','editIter','Callback','')
handles.editError=uicontrol(f,'unit','normalized','BackgroundColor',[1,1,1],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.6325,0.1843386,0.115625,0.047619],'Relief','sunken','SliderStep',[0.01,0.1],'String','0','Style','edit','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','editError','Callback','')
handles.editStep=uicontrol(f,'unit','normalized','BackgroundColor',[1,1,1],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.6325,0.1175397,0.115625,0.047619],'Relief','sunken','SliderStep',[0.01,0.1],'String','0.1','Style','edit','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','editStep','Callback','')
handles.txtNummf=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.4390625,0.3156349,0.1671875,0.0436508],'Relief','flat','SliderStep',[0.01,0.1],'String','Number of MF :','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtNummf','Callback','')
handles.txtIter=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.4515625,0.2580952,0.1484375,0.0416667],'Relief','flat','SliderStep',[0.01,0.1],'String','Iterations :','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtIter','Callback','')
handles.txtError=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.4546875,0.192619,0.140625,0.0456349],'Relief','flat','SliderStep',[0.01,0.1],'String','Error : ','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtError','Callback','')
handles.txtStep=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.4515625,0.1172222,0.1484375,0.0357143],'Relief','flat','SliderStep',[0.01,0.1],'String','StepSize :','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtStep','Callback','')
handles.pbTrain=uicontrol(f,'unit','normalized','BackgroundColor',[0.6,0.6,0.6],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[18],'FontUnits','points','FontWeight','bold','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.474375,0.0315079,0.278125,0.069127],'Relief','raised','SliderStep',[0.01,0.1],'String','$Train$','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','pbTrain','Callback','pbTrain_callback(handles)')
handles.pbPlotTrain=uicontrol(f,'unit','normalized','BackgroundColor',[0.6,0.6,0.6],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[16],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.8006042,0.3807692,0.18,0.0580769],'Relief','raised','SliderStep',[0.01,0.1],'String','$Training Data$','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','pbPlotTrain','Callback','pbPlotTrain_callback(handles)')
handles.pbValidate=uicontrol(f,'unit','normalized','BackgroundColor',[0.6,0.6,0.6],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[16],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.8006042,0.3019231,0.18,0.0623077],'Relief','raised','SliderStep',[0.01,0.1],'String','$Validating Data$','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','pbValidate','Callback','pbValidate_callback(handles)')
handles.pbExport=uicontrol(f,'unit','normalized','BackgroundColor',[0.6,0.6,0.6],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[16],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.8006042,0.2219231,0.18,0.0623077],'Relief','raised','SliderStep',[0.01,0.1],'String','$Export Model$','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','pbValidate','Callback','pbExport_callback(handles)')


handles.txtNumIn=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.79,0.9,0.18,0.04],'Relief','flat','SliderStep',[0.01,0.1],'String','# input var : -','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtNumIn','Callback','')

handles.txtNumOut=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.79,0.86,0.18,0.04],'Relief','flat','SliderStep',[0.01,0.1],'String','# output var : -','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtNumOut','Callback','')

handles.txtNumMF=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.79,0.82,0.18,0.04],'Relief','flat','SliderStep',[0.01,0.1],'String','# mem func : -','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtNumMF','Callback','')

handles.txtDataNum=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.79,0.78,0.18,0.04],'Relief','flat','SliderStep',[0.01,0.1],'String','# train data : -','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtDataNum','Callback','')

handles.txtDataNum2=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.79,0.74,0.18,0.04],'Relief','flat','SliderStep',[0.01,0.1],'String','# test data : -','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','txtDataNum2','Callback','')
//0.8,0.52,0.18,0.45


handles = resume(handles)
endfunction

//////////
// Callbacks are defined as below. Please do not delete the comments as it will be used in coming version
//////////



function rdTraining_callback(handles)
//Write your callback for  rdTraining  here
handles.rdTraining.value = 1;
handles.rdTesting.value = 0;

endfunction


function rdTesting_callback(handles)
//Write your callback for  rdTesting  here
handles.rdTraining.value = 0;
handles.rdTesting.value = 1;

endfunction


function rdFile_callback(handles)
//Write your callback for  rdFile  here
handles.rdFile.value = 1;
handles.rdWorkspace.value = 0;

endfunction


function rdWorkspace_callback(handles)
//Write your callback for  rdWorkspace  here
handles.rdFile.value = 0;
handles.rdWorkspace.value = 1;

endfunction


function pbLoad_callback(handles)
//Write your callback for  pbLoad  here

//if handles.rdTraining.value ==1 then

if handles.rdFile.value == 1 then
    fn=uigetfile(["*.*"]);
    if ~isempty(fn) then
        data = fscanfMat(fn);
    end
    
else
    sci_var = x_dialog(['Scilab Variable : '],'M');
    data = evstr(sci_var);;
    fn = 1;
end

if ~isempty(fn) 

    [row,col] = size(data);

    if ~isempty(handles.axes1.children)
        delete(handles.axes1.children);
    end

    if col <= 1 then
        error('Data must have at least 2 columns, loaded data only has ' + string(col) + ' column.');
    elseif  col == 2 then
        plot(data(:,1),data(:,2),'o-');
        handles.axes1.data_bounds = [min(data(:,1)), min(data(:,2));max(data(:,1)), max(data(:,2))];
    elseif  col > 2 then
        plot(data(:,$),'o-');
        handles.axes1.data_bounds = [1, min(data(:,$));size(data,1), max(data(:,$))];
    end
    
    if  handles.rdTraining.value ==1 then
        handles.traindata = data; 
        handles.txtDataNum.string = ["# train data : " + string(row)];
    else
        handles.testdata = data; 
        handles.txtDataNum2.string = ["# test data : " + string(row)];
    end
    
    handles.txtNumIn.string = ["# input var : " + string(col-1)];
    handles.txtNumOut.string = ["# output var : " + string(1)];
    handles.txtNumMF.string = ["# mem func : " + handles.editNummf.string];
    
else
    
end

 
handles = resume(handles);

endfunction


function pbClear_callback(handles)
//Write your callback for  pbClear  here

if ~isempty(handles.axes1.children)
    delete(handles.axes1.children);
end

if isfield(handles,'traindata') then
    handles.traindata = null();
end
if isfield(handles,'testdata') then
    handles.testdata = null();
end
if isfield(handles,'fls') then
    handles.fls = null();
end

handles.txtDataNum.string = ["# train data : -"];
handles.txtDataNum2.string = ["# test data : -"];
handles.txtNumIn.string = ["# input var : -"];
handles.txtNumOut.string = ["# output var : -"];
handles.txtNumMF.string = ["# mem func : -"];

handles = resume(handles);


endfunction


function popMF_callback(handles)
//Write your callback for  popMF  here

endfunction


function popMethod_callback(handles)
//Write your callback for  popMethod  here

endfunction

function editNummf_callback(handles)
//Write your callback for  popMethod  here
handles.txtNumMF.string = ["# output var : " + handles.editNummf.string];
handles = resume(handles);
endfunction

function pbTrain_callback(handles)
//Write your callback for  pbTrain  here

if isfield(handles,'traindata')
    
traindata = handles.traindata;
mf = handles.popMF.string(handles.popMF.value);
L = strtod(handles.editNummf.string);
itr = strtod(handles.editIter.string);
err = strtod(handles.editError.string);
step_sz = strtod(handles.editStep.string);
//pause
//[fls,evol] = anfis(traindata,mf,L,itr,err,step_sz);

//if ~isfield(handles,'fls')
//    fls = initanfis(traindata,L,mf);
//elseif size(fls.input(1).mf) ~= L
//    fls = initanfis(traindata,L,mf);
//end
fls = initanfis(traindata,L,mf);
[fls,evol] = anfis(traindata,fls,itr,err,step_sz)

if ~isempty(handles.axes1.children)
    delete(handles.axes1.children);
end

plot(evol(:,1),evol(:,2),'r--*',evol(:,1),evol(:,3),'g--*');
handles.axes1.data_bounds = [min(evol(:,1)), min([evol(:,2),evol(:,3)]);max(evol(:,1)), max([evol(:,2),evol(:,3)])];

handles.fls = list();
handles.fls = fls;
handles = resume(handles);
else
    messagebox('Training data not loaded.','No Data Loaded','error');
end

endfunction


function pbPlotTrain_callback(handles)
//Write your callback for  pbPlotTrain  here

fls = handles.fls;
traindata = handles.traindata;
out = evalfls(traindata(:,1:$-1),fls);

if ~isempty(handles.axes1.children)
    delete(handles.axes1.children);
end

if  size(fls.input) == 1 then
    plot(traindata(:,1),traindata(:,2),'o-');
    plot(traindata(:,1),out,'*r-');
    minx = min(traindata(:,1));
    maxx = max(traindata(:,1));
    miny = min([traindata(:,2) out]);
    maxy = max([traindata(:,2) out]);
    handles.axes1.data_bounds = [minx miny;maxx,maxy];
else
    plot(traindata(:,$),'o-');
    plot(out,'*r-');
    minx = 1;
    maxx = size(traindata,1);
    miny = min([traindata(:,$) out]);
    maxy = max([traindata(:,$) out]);
    handles.axes1.data_bounds = [minx miny;maxx,maxy];
end


endfunction


function pbValidate_callback(handles)
//Write your callback for  pbValidate  here

if isfield(handles,'testdata')

    fls = handles.fls;
    testdata = handles.testdata;
    out = evalfls(testdata(:,1:$-1),fls);



    if ~isempty(handles.axes1.children)
        delete(handles.axes1.children);
    end

    if  size(fls.input) == 1 then
        plot(testdata(:,1),testdata(:,2),'o-');
        plot(testdata(:,1),out,'*r-');
        minx = min(testdata(:,1));
        maxx = max(testdata(:,1));
        miny = min([testdata(:,2) out]);
        maxy = max([testdata(:,2) out]);
        handles.axes1.data_bounds = [minx miny;maxx,maxy];
    else
        plot(testdata(:,$),'o-');
        plot(out,'*r-');
        minx = 1;
        maxx = size(testdata,1);
        miny = min([testdata(:,$) out]);
        maxy = max([testdata(:,$) out]);
        handles.axes1.data_bounds = [minx miny;maxx,maxy];
    end

else
    messagebox('Testing data not loaded.','No Data Loaded','error');
end

endfunction


function pbExport_callback(handles)
//Write your callback for  pbExport  here

    fls = handles.fls;
    anfis_name=x_dialog('Variable Name','fls')
    str = anfis_name + '= resume(fls)';
    execstr(str);
    //myfls = resume(fls);

endfunction

function pbDemo_callback(handles)
//Write your callback for  pbDemo  here

x = (0:0.1:10)';
y = sin(2*x)./exp(x/5);
data = [x y];

[row,col] = size(data);

if ~isempty(handles.axes1.children)
    delete(handles.axes1.children);
end

if col <= 1 then
    error('Data must have at least 2 columns, loaded data only has ' + string(col) + ' column.');
elseif  col == 2 then
    plot(data(:,1),data(:,2),'o-');
    handles.axes1.data_bounds = [min(data(:,1)), min(data(:,2));max(data(:,1)), max(data(:,2))];
elseif  col > 2 then
    plot(data(:,$),'o-');
    handles.axes1.data_bounds = [1, min(data(:,$));size(data,1), max(data(:,$))];
end

handles.traindata = data; 
handles.txtDataNum.string = ["# train data : " + string(row)];

handles.txtNumIn.string = ["# input var : " + string(col-1)];
handles.txtNumOut.string = ["# output var : " + string(1)];
handles.txtNumMF.string = ["# mem func : " + handles.editNummf.string];





 
handles = resume(handles);

endfunction
