function [fls,evola] = anfis2(traindata,mf,L,itr,err,step_sz)
   
winId=progressionbar('Please Wait...');    
//gbellmf, trimf, trapmf
// Checking Input Arguement
rhs=argn(2);

// Error Checking
if rhs < 1; error("Expect at least 1 argument, traindata");end
if rhs < 2; mf = 'gbellmf'; end
if rhs < 3; L = 2; end
if rhs < 4; itr = 30; end
if rhs < 5; err = 0; end        
if rhs < 6; step_sz = 0.1; end        
    
    
    if strcmp(mf,'gbellmf','i')==0 then
        mf_ind = 2;
    elseif strcmp(mf,'trapmf','i')==0 then
        mf_ind = 3;
    elseif strcmp(mf,'trimf','i')==0 then
        mf_ind = 4;
    else
        error("flslab only support gbellmf, trimf, trapmf at the moment.");
    end

// Number of inputs data calculated automatically
pin = size(traindata,1);
k = size(traindata,2) - 1;

// Initialize Training Variables
abc=abcfixed(traindata,L,mf_ind)
//pause
pqr=ones(L^k,(k+1));

// Number of outputs data calculated automatically
valdata = [];
if valdata==[] then
    pchk=0;valdata=zeros(1,k+1)
end

// Training
[abc,pqr,evola]=hytrain(k,L,pin,pchk,mf_ind,itr,err,step_sz,abc,pqr,traindata,valdata);
//pause
//out=check(k,L,101,mf_ind,abc,pqr,traindata);

//////////////////////////////////////////////////////////////////////
// Structure Convertion from flsLAB to SCIFLT to integrate 2 modules
//////////////////////////////////////////////////////////////////////

if mf_ind == 1 | mf_ind == 2 then   // bell_1 and bell_2, bell_1 is currently not used
    abc2 = abc; // For Bell2 == gbellmf
    mem_func = 'gbellmf';
elseif mf_ind ==3   // Trapezoidal
    abc2(:,2) = abc(:,3) - abc(:,2) ./ 2; // For Tranp
    abc2(:,3) = abc(:,3) + abc(:,2) ./ 2;
    abc2(:,1) = abc2(:,2)- 1 ./ abc(:,1);
    abc2(:,4) = 1 ./ abc(:,1) + abc2(:,3);
    mem_func = 'trapmf';
elseif mf_ind ==4   // Triangular
    abc2(:,2) = abc(:,3); // For Trianglar
    abc2(:,1) = abc(:,3)- 1 ./ abc(:,1);
    abc2(:,3) = 1 ./ abc(:,1) + abc(:,3);
    mem_func = 'trimf';
end

fls=newfls();
fls.ImpMethod = 'prod'
fls.AggMethod = 'sum'
fls.defuzzMethod = 'wtaver'


// L membership function per input
// k input variables

// Define empty list for variable and membership function
flsvar_def=tlist(['flsvar','name','range','mf'],"",[],list());
flsmf_def=tlist(['flsmf','name','type','par'],"","",[]);
flsvar=flsvar_def
flsmf=flsmf_def;

// Creating input nodes
for cnt_var = 1:k
    flsvar.name = 'input'+string(cnt_var);
    range_min = min(traindata(:,cnt_var));
    range_max = max(traindata(:,cnt_var));
    flsvar.range = [range_min range_max];
    fls.input(cnt_var) = flsvar;
    // Creating nodes members
    for cnt_mf = 1:L
        flsmf.name = 'in' + string(cnt_var) + 'mf'+string(cnt_mf); 
        flsmf.type = mem_func; 
        flsmf.par =abc2((cnt_var-1)*L+cnt_mf,:);
        fls.input(cnt_var).mf(cnt_mf) = flsmf;
    end
end


num_outmf = size(pqr,1);

flsvar=flsvar_def
flsmf=flsmf_def;

flsvar.name = 'output1';
range_min = min(traindata(:,$));
range_max = max(traindata(:,$));
flsvar.range = [range_min range_max];
fls.output(1) = flsvar;

for cnt = 1:num_outmf
    flsmf.name = 'out1mf'+string(cnt); 
    flsmf.type = 'linear'; 
    flsmf.par =pqr(cnt,:);
    fls.output(1).mf(cnt) = flsmf;
end

//fls.rule = [1 1 1 1;2 2 1 1;3 3 1 1;4 4 1 1; 5 5 1 1];

r1 = specfun_combinerepeat (1:L,k)';
//r1 = flipdim(r1,1)';
r2 = [1:L^k]';
r3 = ones(L^k,2);

fls.rule = [r1 r2 r3];
//num_outmf = size(abc,1);
//
//fls.output(1).name = 'output1';
//fls.output(1).range = [0 30];
//
//for cnt = 1:num_outmf
//    fls.output(1).mf(cnt).name = 'out1mf'+string(cnt); 
//    fls.output(1).mf(cnt).type = 'linear'; 
//    fls.output(1).mf(cnt).par =pqr(cnt,:);
//end
//
//fls.rule = [1 1 1 1;2 2 1 1;3 3 1 1;4 4 1 1; 5 5 1 1];
//
//
//
close(winId);

endfunction
