function [k,L,FP,ka,abc,pqr]=import(Ein,Echk,ET1,ET4,Lst1,Lst3,Lst4,T7,E5,E6)
// ANFISLAB: Toolbox de ANFIS (ADAPTATIVE-NETWORK-BASED-FUZZY INFERENCE SYSTEM) para SCILAB
// Creado Por Andres G. Avendaño Cabezas., Universidad Central de Venezuela (andrewg.avendano@gmail.com),
// Agosto de 2009, con adaptaciones del codigo ANFIS de dominio publico de Jyh-shing Roger Jang
// (http://www.cs.nthu.edu.tw/~jang/publication.htm) y FISLAB de G. Ortega.
// Este programa fue probado en SCILAB version 5.1.1, PC Intel Core(TM) Duo 2,1Ghz, corriendo Linux 2.6.27.7

// Import: Importa los parámetros del sistema desde un archivo de texto.
direccion=uigetfile(["*.*"],direccion);
M = fscanfMat(direccion);
[a,b]=size(M)
k=M(1,1);
L=M(2,1);
FP=M(3,1);
ka=M(4,1);
abct=M(5: (4+3*k*L) ,1);
//pause
pqrt=M( (5+3*k*L):a,1);
[b,xd]=size(pqrt);
xc=b/L^k;
pqr=matrix(pqrt,L^k,xc);
abc=matrix(abct,k*L,3);
err='inf';
set(Lst1,"value",FP);
set(ET1,"string",string(L));
set(ET4,"string",string(ka));
if Ein~=[] then
  grafica(Ein,k,abc,FP,L);
  set(E5,"enable","on");
end
if Echk~=[] then
  grafica(Echk,k,abc,FP,L);
  set(E6,"enable","on");
end
pqr=matrix(pqr,(L^k),(k+1))
showres(abc,pqr,err,L,k,Lst3,Lst4,T7)
endfunction
